/**
 * @since 1.0.0
 */
import { type AddTagsToOnPremisesInstancesCommandInput, type AddTagsToOnPremisesInstancesCommandOutput, type BatchGetApplicationRevisionsCommandInput, type BatchGetApplicationRevisionsCommandOutput, type BatchGetApplicationsCommandInput, type BatchGetApplicationsCommandOutput, type BatchGetDeploymentGroupsCommandInput, type BatchGetDeploymentGroupsCommandOutput, type BatchGetDeploymentInstancesCommandInput, type BatchGetDeploymentInstancesCommandOutput, type BatchGetDeploymentsCommandInput, type BatchGetDeploymentsCommandOutput, type BatchGetDeploymentTargetsCommandInput, type BatchGetDeploymentTargetsCommandOutput, type BatchGetOnPremisesInstancesCommandInput, type BatchGetOnPremisesInstancesCommandOutput, type CodeDeployClient, type CodeDeployClientConfig, type ContinueDeploymentCommandInput, type ContinueDeploymentCommandOutput, type CreateApplicationCommandInput, type CreateApplicationCommandOutput, type CreateDeploymentCommandInput, type CreateDeploymentCommandOutput, type CreateDeploymentConfigCommandInput, type CreateDeploymentConfigCommandOutput, type CreateDeploymentGroupCommandInput, type CreateDeploymentGroupCommandOutput, type DeleteApplicationCommandInput, type DeleteApplicationCommandOutput, type DeleteDeploymentConfigCommandInput, type DeleteDeploymentConfigCommandOutput, type DeleteDeploymentGroupCommandInput, type DeleteDeploymentGroupCommandOutput, type DeleteGitHubAccountTokenCommandInput, type DeleteGitHubAccountTokenCommandOutput, type DeleteResourcesByExternalIdCommandInput, type DeleteResourcesByExternalIdCommandOutput, type DeregisterOnPremisesInstanceCommandInput, type DeregisterOnPremisesInstanceCommandOutput, type GetApplicationCommandInput, type GetApplicationCommandOutput, type GetApplicationRevisionCommandInput, type GetApplicationRevisionCommandOutput, type GetDeploymentCommandInput, type GetDeploymentCommandOutput, type GetDeploymentConfigCommandInput, type GetDeploymentConfigCommandOutput, type GetDeploymentGroupCommandInput, type GetDeploymentGroupCommandOutput, type GetDeploymentInstanceCommandInput, type GetDeploymentInstanceCommandOutput, type GetDeploymentTargetCommandInput, type GetDeploymentTargetCommandOutput, type GetOnPremisesInstanceCommandInput, type GetOnPremisesInstanceCommandOutput, type ListApplicationRevisionsCommandInput, type ListApplicationRevisionsCommandOutput, type ListApplicationsCommandInput, type ListApplicationsCommandOutput, type ListDeploymentConfigsCommandInput, type ListDeploymentConfigsCommandOutput, type ListDeploymentGroupsCommandInput, type ListDeploymentGroupsCommandOutput, type ListDeploymentInstancesCommandInput, type ListDeploymentInstancesCommandOutput, type ListDeploymentsCommandInput, type ListDeploymentsCommandOutput, type ListDeploymentTargetsCommandInput, type ListDeploymentTargetsCommandOutput, type ListGitHubAccountTokenNamesCommandInput, type ListGitHubAccountTokenNamesCommandOutput, type ListOnPremisesInstancesCommandInput, type ListOnPremisesInstancesCommandOutput, type ListTagsForResourceCommandInput, type ListTagsForResourceCommandOutput, type PutLifecycleEventHookExecutionStatusCommandInput, type PutLifecycleEventHookExecutionStatusCommandOutput, type RegisterApplicationRevisionCommandInput, type RegisterApplicationRevisionCommandOutput, type RegisterOnPremisesInstanceCommandInput, type RegisterOnPremisesInstanceCommandOutput, type RemoveTagsFromOnPremisesInstancesCommandInput, type RemoveTagsFromOnPremisesInstancesCommandOutput, type SkipWaitTimeForInstanceTerminationCommandInput, type SkipWaitTimeForInstanceTerminationCommandOutput, type StopDeploymentCommandInput, type StopDeploymentCommandOutput, type TagResourceCommandInput, type TagResourceCommandOutput, type UntagResourceCommandInput, type UntagResourceCommandOutput, type UpdateApplicationCommandInput, type UpdateApplicationCommandOutput, type UpdateDeploymentGroupCommandInput, type UpdateDeploymentGroupCommandOutput } from "@aws-sdk/client-codedeploy";
import type { HttpHandlerOptions, SdkError, ServiceLogger } from "@effect-aws/commons";
import type { Cause } from "effect";
import { Effect, Layer } from "effect";
import * as Instance from "./CodeDeployClientInstance.js";
import type { AlarmsLimitExceededError, ApplicationAlreadyExistsError, ApplicationDoesNotExistError, ApplicationLimitExceededError, ApplicationNameRequiredError, ArnNotSupportedError, BatchLimitExceededError, BucketNameFilterRequiredError, DeploymentAlreadyCompletedError, DeploymentConfigAlreadyExistsError, DeploymentConfigDoesNotExistError, DeploymentConfigInUseError, DeploymentConfigLimitExceededError, DeploymentConfigNameRequiredError, DeploymentDoesNotExistError, DeploymentGroupAlreadyExistsError, DeploymentGroupDoesNotExistError, DeploymentGroupLimitExceededError, DeploymentGroupNameRequiredError, DeploymentIdRequiredError, DeploymentIsNotInReadyStateError, DeploymentLimitExceededError, DeploymentNotStartedError, DeploymentTargetDoesNotExistError, DeploymentTargetIdRequiredError, DeploymentTargetListSizeExceededError, DescriptionTooLongError, ECSServiceMappingLimitExceededError, GitHubAccountTokenDoesNotExistError, GitHubAccountTokenNameRequiredError, IamArnRequiredError, IamSessionArnAlreadyRegisteredError, IamUserArnAlreadyRegisteredError, IamUserArnRequiredError, InstanceDoesNotExistError, InstanceIdRequiredError, InstanceLimitExceededError, InstanceNameAlreadyRegisteredError, InstanceNameRequiredError, InstanceNotRegisteredError, InvalidAlarmConfigError, InvalidApplicationNameError, InvalidArnError, InvalidAutoRollbackConfigError, InvalidAutoScalingGroupError, InvalidBlueGreenDeploymentConfigurationError, InvalidBucketNameFilterError, InvalidComputePlatformError, InvalidDeployedStateFilterError, InvalidDeploymentConfigNameError, InvalidDeploymentGroupNameError, InvalidDeploymentIdError, InvalidDeploymentInstanceTypeError, InvalidDeploymentStatusError, InvalidDeploymentStyleError, InvalidDeploymentTargetIdError, InvalidDeploymentWaitTypeError, InvalidEC2TagCombinationError, InvalidEC2TagError, InvalidECSServiceError, InvalidExternalIdError, InvalidFileExistsBehaviorError, InvalidGitHubAccountTokenError, InvalidGitHubAccountTokenNameError, InvalidIamSessionArnError, InvalidIamUserArnError, InvalidIgnoreApplicationStopFailuresValueError, InvalidInputError, InvalidInstanceNameError, InvalidInstanceStatusError, InvalidInstanceTypeError, InvalidKeyPrefixFilterError, InvalidLifecycleEventHookExecutionIdError, InvalidLifecycleEventHookExecutionStatusError, InvalidLoadBalancerInfoError, InvalidMinimumHealthyHostValueError, InvalidNextTokenError, InvalidOnPremisesTagCombinationError, InvalidOperationError, InvalidRegistrationStatusError, InvalidRevisionError, InvalidRoleError, InvalidSortByError, InvalidSortOrderError, InvalidTagError, InvalidTagFilterError, InvalidTagsToAddError, InvalidTargetFilterNameError, InvalidTargetGroupPairError, InvalidTargetInstancesError, InvalidTimeRangeError, InvalidTrafficRoutingConfigurationError, InvalidTriggerConfigError, InvalidUpdateOutdatedInstancesOnlyValueError, InvalidZonalDeploymentConfigurationError, LifecycleEventAlreadyCompletedError, LifecycleHookLimitExceededError, MultipleIamArnsProvidedError, OperationNotSupportedError, ResourceArnRequiredError, ResourceValidationError, RevisionDoesNotExistError, RevisionRequiredError, RoleRequiredError, TagLimitExceededError, TagRequiredError, TagSetListLimitExceededError, ThrottlingError, TriggerTargetsLimitExceededError, UnsupportedActionForDeploymentTypeError } from "./Errors.js";
interface CodeDeployService$ {
    readonly _: unique symbol;
    /**
     * @see {@link AddTagsToOnPremisesInstancesCommand}
     */
    addTagsToOnPremisesInstances(args: AddTagsToOnPremisesInstancesCommandInput, options?: HttpHandlerOptions): Effect.Effect<AddTagsToOnPremisesInstancesCommandOutput, Cause.TimeoutException | SdkError | InstanceLimitExceededError | InstanceNameRequiredError | InstanceNotRegisteredError | InvalidInstanceNameError | InvalidTagError | TagLimitExceededError | TagRequiredError>;
    /**
     * @see {@link BatchGetApplicationRevisionsCommand}
     */
    batchGetApplicationRevisions(args: BatchGetApplicationRevisionsCommandInput, options?: HttpHandlerOptions): Effect.Effect<BatchGetApplicationRevisionsCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | BatchLimitExceededError | InvalidApplicationNameError | InvalidRevisionError | RevisionRequiredError>;
    /**
     * @see {@link BatchGetApplicationsCommand}
     */
    batchGetApplications(args: BatchGetApplicationsCommandInput, options?: HttpHandlerOptions): Effect.Effect<BatchGetApplicationsCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | BatchLimitExceededError | InvalidApplicationNameError>;
    /**
     * @see {@link BatchGetDeploymentGroupsCommand}
     */
    batchGetDeploymentGroups(args: BatchGetDeploymentGroupsCommandInput, options?: HttpHandlerOptions): Effect.Effect<BatchGetDeploymentGroupsCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | BatchLimitExceededError | DeploymentConfigDoesNotExistError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError>;
    /**
     * @see {@link BatchGetDeploymentInstancesCommand}
     */
    batchGetDeploymentInstances(args: BatchGetDeploymentInstancesCommandInput, options?: HttpHandlerOptions): Effect.Effect<BatchGetDeploymentInstancesCommandOutput, Cause.TimeoutException | SdkError | BatchLimitExceededError | DeploymentDoesNotExistError | DeploymentIdRequiredError | InstanceIdRequiredError | InvalidComputePlatformError | InvalidDeploymentIdError | InvalidInstanceNameError>;
    /**
     * @see {@link BatchGetDeploymentTargetsCommand}
     */
    batchGetDeploymentTargets(args: BatchGetDeploymentTargetsCommandInput, options?: HttpHandlerOptions): Effect.Effect<BatchGetDeploymentTargetsCommandOutput, Cause.TimeoutException | SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | DeploymentTargetDoesNotExistError | DeploymentTargetIdRequiredError | DeploymentTargetListSizeExceededError | InstanceDoesNotExistError | InvalidDeploymentIdError | InvalidDeploymentTargetIdError>;
    /**
     * @see {@link BatchGetDeploymentsCommand}
     */
    batchGetDeployments(args: BatchGetDeploymentsCommandInput, options?: HttpHandlerOptions): Effect.Effect<BatchGetDeploymentsCommandOutput, Cause.TimeoutException | SdkError | BatchLimitExceededError | DeploymentIdRequiredError | InvalidDeploymentIdError>;
    /**
     * @see {@link BatchGetOnPremisesInstancesCommand}
     */
    batchGetOnPremisesInstances(args: BatchGetOnPremisesInstancesCommandInput, options?: HttpHandlerOptions): Effect.Effect<BatchGetOnPremisesInstancesCommandOutput, Cause.TimeoutException | SdkError | BatchLimitExceededError | InstanceNameRequiredError | InvalidInstanceNameError>;
    /**
     * @see {@link ContinueDeploymentCommand}
     */
    continueDeployment(args: ContinueDeploymentCommandInput, options?: HttpHandlerOptions): Effect.Effect<ContinueDeploymentCommandOutput, Cause.TimeoutException | SdkError | DeploymentAlreadyCompletedError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentIsNotInReadyStateError | InvalidDeploymentIdError | InvalidDeploymentStatusError | InvalidDeploymentWaitTypeError | UnsupportedActionForDeploymentTypeError>;
    /**
     * @see {@link CreateApplicationCommand}
     */
    createApplication(args: CreateApplicationCommandInput, options?: HttpHandlerOptions): Effect.Effect<CreateApplicationCommandOutput, Cause.TimeoutException | SdkError | ApplicationAlreadyExistsError | ApplicationLimitExceededError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidComputePlatformError | InvalidTagsToAddError>;
    /**
     * @see {@link CreateDeploymentCommand}
     */
    createDeployment(args: CreateDeploymentCommandInput, options?: HttpHandlerOptions): Effect.Effect<CreateDeploymentCommandOutput, Cause.TimeoutException | SdkError | AlarmsLimitExceededError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | DeploymentLimitExceededError | DescriptionTooLongError | InvalidAlarmConfigError | InvalidApplicationNameError | InvalidAutoRollbackConfigError | InvalidAutoScalingGroupError | InvalidDeploymentConfigNameError | InvalidDeploymentGroupNameError | InvalidFileExistsBehaviorError | InvalidGitHubAccountTokenError | InvalidIgnoreApplicationStopFailuresValueError | InvalidLoadBalancerInfoError | InvalidRevisionError | InvalidRoleError | InvalidTargetInstancesError | InvalidTrafficRoutingConfigurationError | InvalidUpdateOutdatedInstancesOnlyValueError | RevisionDoesNotExistError | RevisionRequiredError | ThrottlingError>;
    /**
     * @see {@link CreateDeploymentConfigCommand}
     */
    createDeploymentConfig(args: CreateDeploymentConfigCommandInput, options?: HttpHandlerOptions): Effect.Effect<CreateDeploymentConfigCommandOutput, Cause.TimeoutException | SdkError | DeploymentConfigAlreadyExistsError | DeploymentConfigLimitExceededError | DeploymentConfigNameRequiredError | InvalidComputePlatformError | InvalidDeploymentConfigNameError | InvalidMinimumHealthyHostValueError | InvalidTrafficRoutingConfigurationError | InvalidZonalDeploymentConfigurationError>;
    /**
     * @see {@link CreateDeploymentGroupCommand}
     */
    createDeploymentGroup(args: CreateDeploymentGroupCommandInput, options?: HttpHandlerOptions): Effect.Effect<CreateDeploymentGroupCommandOutput, Cause.TimeoutException | SdkError | AlarmsLimitExceededError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupAlreadyExistsError | DeploymentGroupLimitExceededError | DeploymentGroupNameRequiredError | ECSServiceMappingLimitExceededError | InvalidAlarmConfigError | InvalidApplicationNameError | InvalidAutoRollbackConfigError | InvalidAutoScalingGroupError | InvalidBlueGreenDeploymentConfigurationError | InvalidDeploymentConfigNameError | InvalidDeploymentGroupNameError | InvalidDeploymentStyleError | InvalidEC2TagCombinationError | InvalidEC2TagError | InvalidECSServiceError | InvalidInputError | InvalidLoadBalancerInfoError | InvalidOnPremisesTagCombinationError | InvalidRoleError | InvalidTagError | InvalidTagsToAddError | InvalidTargetGroupPairError | InvalidTrafficRoutingConfigurationError | InvalidTriggerConfigError | LifecycleHookLimitExceededError | RoleRequiredError | TagSetListLimitExceededError | ThrottlingError | TriggerTargetsLimitExceededError>;
    /**
     * @see {@link DeleteApplicationCommand}
     */
    deleteApplication(args: DeleteApplicationCommandInput, options?: HttpHandlerOptions): Effect.Effect<DeleteApplicationCommandOutput, Cause.TimeoutException | SdkError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidRoleError>;
    /**
     * @see {@link DeleteDeploymentConfigCommand}
     */
    deleteDeploymentConfig(args: DeleteDeploymentConfigCommandInput, options?: HttpHandlerOptions): Effect.Effect<DeleteDeploymentConfigCommandOutput, Cause.TimeoutException | SdkError | DeploymentConfigInUseError | DeploymentConfigNameRequiredError | InvalidDeploymentConfigNameError | InvalidOperationError>;
    /**
     * @see {@link DeleteDeploymentGroupCommand}
     */
    deleteDeploymentGroup(args: DeleteDeploymentGroupCommandInput, options?: HttpHandlerOptions): Effect.Effect<DeleteDeploymentGroupCommandOutput, Cause.TimeoutException | SdkError | ApplicationNameRequiredError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError | InvalidRoleError>;
    /**
     * @see {@link DeleteGitHubAccountTokenCommand}
     */
    deleteGitHubAccountToken(args: DeleteGitHubAccountTokenCommandInput, options?: HttpHandlerOptions): Effect.Effect<DeleteGitHubAccountTokenCommandOutput, Cause.TimeoutException | SdkError | GitHubAccountTokenDoesNotExistError | GitHubAccountTokenNameRequiredError | InvalidGitHubAccountTokenNameError | OperationNotSupportedError | ResourceValidationError>;
    /**
     * @see {@link DeleteResourcesByExternalIdCommand}
     */
    deleteResourcesByExternalId(args: DeleteResourcesByExternalIdCommandInput, options?: HttpHandlerOptions): Effect.Effect<DeleteResourcesByExternalIdCommandOutput, Cause.TimeoutException | SdkError>;
    /**
     * @see {@link DeregisterOnPremisesInstanceCommand}
     */
    deregisterOnPremisesInstance(args: DeregisterOnPremisesInstanceCommandInput, options?: HttpHandlerOptions): Effect.Effect<DeregisterOnPremisesInstanceCommandOutput, Cause.TimeoutException | SdkError | InstanceNameRequiredError | InvalidInstanceNameError>;
    /**
     * @see {@link GetApplicationCommand}
     */
    getApplication(args: GetApplicationCommandInput, options?: HttpHandlerOptions): Effect.Effect<GetApplicationCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError>;
    /**
     * @see {@link GetApplicationRevisionCommand}
     */
    getApplicationRevision(args: GetApplicationRevisionCommandInput, options?: HttpHandlerOptions): Effect.Effect<GetApplicationRevisionCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidRevisionError | RevisionDoesNotExistError | RevisionRequiredError>;
    /**
     * @see {@link GetDeploymentCommand}
     */
    getDeployment(args: GetDeploymentCommandInput, options?: HttpHandlerOptions): Effect.Effect<GetDeploymentCommandOutput, Cause.TimeoutException | SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | InvalidDeploymentIdError>;
    /**
     * @see {@link GetDeploymentConfigCommand}
     */
    getDeploymentConfig(args: GetDeploymentConfigCommandInput, options?: HttpHandlerOptions): Effect.Effect<GetDeploymentConfigCommandOutput, Cause.TimeoutException | SdkError | DeploymentConfigDoesNotExistError | DeploymentConfigNameRequiredError | InvalidComputePlatformError | InvalidDeploymentConfigNameError>;
    /**
     * @see {@link GetDeploymentGroupCommand}
     */
    getDeploymentGroup(args: GetDeploymentGroupCommandInput, options?: HttpHandlerOptions): Effect.Effect<GetDeploymentGroupCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError>;
    /**
     * @see {@link GetDeploymentInstanceCommand}
     */
    getDeploymentInstance(args: GetDeploymentInstanceCommandInput, options?: HttpHandlerOptions): Effect.Effect<GetDeploymentInstanceCommandOutput, Cause.TimeoutException | SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | InstanceDoesNotExistError | InstanceIdRequiredError | InvalidComputePlatformError | InvalidDeploymentIdError | InvalidInstanceNameError>;
    /**
     * @see {@link GetDeploymentTargetCommand}
     */
    getDeploymentTarget(args: GetDeploymentTargetCommandInput, options?: HttpHandlerOptions): Effect.Effect<GetDeploymentTargetCommandOutput, Cause.TimeoutException | SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | DeploymentTargetDoesNotExistError | DeploymentTargetIdRequiredError | InvalidDeploymentIdError | InvalidDeploymentTargetIdError | InvalidInstanceNameError>;
    /**
     * @see {@link GetOnPremisesInstanceCommand}
     */
    getOnPremisesInstance(args: GetOnPremisesInstanceCommandInput, options?: HttpHandlerOptions): Effect.Effect<GetOnPremisesInstanceCommandOutput, Cause.TimeoutException | SdkError | InstanceNameRequiredError | InstanceNotRegisteredError | InvalidInstanceNameError>;
    /**
     * @see {@link ListApplicationRevisionsCommand}
     */
    listApplicationRevisions(args: ListApplicationRevisionsCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListApplicationRevisionsCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | BucketNameFilterRequiredError | InvalidApplicationNameError | InvalidBucketNameFilterError | InvalidDeployedStateFilterError | InvalidKeyPrefixFilterError | InvalidNextTokenError | InvalidSortByError | InvalidSortOrderError>;
    /**
     * @see {@link ListApplicationsCommand}
     */
    listApplications(args: ListApplicationsCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListApplicationsCommandOutput, Cause.TimeoutException | SdkError | InvalidNextTokenError>;
    /**
     * @see {@link ListDeploymentConfigsCommand}
     */
    listDeploymentConfigs(args: ListDeploymentConfigsCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListDeploymentConfigsCommandOutput, Cause.TimeoutException | SdkError | InvalidNextTokenError>;
    /**
     * @see {@link ListDeploymentGroupsCommand}
     */
    listDeploymentGroups(args: ListDeploymentGroupsCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListDeploymentGroupsCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidNextTokenError>;
    /**
     * @see {@link ListDeploymentInstancesCommand}
     */
    listDeploymentInstances(args: ListDeploymentInstancesCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListDeploymentInstancesCommandOutput, Cause.TimeoutException | SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | InvalidComputePlatformError | InvalidDeploymentIdError | InvalidDeploymentInstanceTypeError | InvalidInstanceStatusError | InvalidInstanceTypeError | InvalidNextTokenError | InvalidTargetFilterNameError>;
    /**
     * @see {@link ListDeploymentTargetsCommand}
     */
    listDeploymentTargets(args: ListDeploymentTargetsCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListDeploymentTargetsCommandOutput, Cause.TimeoutException | SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | InvalidDeploymentIdError | InvalidDeploymentInstanceTypeError | InvalidInstanceStatusError | InvalidInstanceTypeError | InvalidNextTokenError | InvalidTargetFilterNameError>;
    /**
     * @see {@link ListDeploymentsCommand}
     */
    listDeployments(args: ListDeploymentsCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListDeploymentsCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError | InvalidDeploymentStatusError | InvalidExternalIdError | InvalidInputError | InvalidNextTokenError | InvalidTimeRangeError>;
    /**
     * @see {@link ListGitHubAccountTokenNamesCommand}
     */
    listGitHubAccountTokenNames(args: ListGitHubAccountTokenNamesCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListGitHubAccountTokenNamesCommandOutput, Cause.TimeoutException | SdkError | InvalidNextTokenError | OperationNotSupportedError | ResourceValidationError>;
    /**
     * @see {@link ListOnPremisesInstancesCommand}
     */
    listOnPremisesInstances(args: ListOnPremisesInstancesCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListOnPremisesInstancesCommandOutput, Cause.TimeoutException | SdkError | InvalidNextTokenError | InvalidRegistrationStatusError | InvalidTagFilterError>;
    /**
     * @see {@link ListTagsForResourceCommand}
     */
    listTagsForResource(args: ListTagsForResourceCommandInput, options?: HttpHandlerOptions): Effect.Effect<ListTagsForResourceCommandOutput, Cause.TimeoutException | SdkError | ArnNotSupportedError | InvalidArnError | ResourceArnRequiredError>;
    /**
     * @see {@link PutLifecycleEventHookExecutionStatusCommand}
     */
    putLifecycleEventHookExecutionStatus(args: PutLifecycleEventHookExecutionStatusCommandInput, options?: HttpHandlerOptions): Effect.Effect<PutLifecycleEventHookExecutionStatusCommandOutput, Cause.TimeoutException | SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | InvalidDeploymentIdError | InvalidLifecycleEventHookExecutionIdError | InvalidLifecycleEventHookExecutionStatusError | LifecycleEventAlreadyCompletedError | UnsupportedActionForDeploymentTypeError>;
    /**
     * @see {@link RegisterApplicationRevisionCommand}
     */
    registerApplicationRevision(args: RegisterApplicationRevisionCommandInput, options?: HttpHandlerOptions): Effect.Effect<RegisterApplicationRevisionCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DescriptionTooLongError | InvalidApplicationNameError | InvalidRevisionError | RevisionRequiredError>;
    /**
     * @see {@link RegisterOnPremisesInstanceCommand}
     */
    registerOnPremisesInstance(args: RegisterOnPremisesInstanceCommandInput, options?: HttpHandlerOptions): Effect.Effect<RegisterOnPremisesInstanceCommandOutput, Cause.TimeoutException | SdkError | IamArnRequiredError | IamSessionArnAlreadyRegisteredError | IamUserArnAlreadyRegisteredError | IamUserArnRequiredError | InstanceNameAlreadyRegisteredError | InstanceNameRequiredError | InvalidIamSessionArnError | InvalidIamUserArnError | InvalidInstanceNameError | MultipleIamArnsProvidedError>;
    /**
     * @see {@link RemoveTagsFromOnPremisesInstancesCommand}
     */
    removeTagsFromOnPremisesInstances(args: RemoveTagsFromOnPremisesInstancesCommandInput, options?: HttpHandlerOptions): Effect.Effect<RemoveTagsFromOnPremisesInstancesCommandOutput, Cause.TimeoutException | SdkError | InstanceLimitExceededError | InstanceNameRequiredError | InstanceNotRegisteredError | InvalidInstanceNameError | InvalidTagError | TagLimitExceededError | TagRequiredError>;
    /**
     * @see {@link SkipWaitTimeForInstanceTerminationCommand}
     */
    skipWaitTimeForInstanceTermination(args: SkipWaitTimeForInstanceTerminationCommandInput, options?: HttpHandlerOptions): Effect.Effect<SkipWaitTimeForInstanceTerminationCommandOutput, Cause.TimeoutException | SdkError | DeploymentAlreadyCompletedError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | InvalidDeploymentIdError | UnsupportedActionForDeploymentTypeError>;
    /**
     * @see {@link StopDeploymentCommand}
     */
    stopDeployment(args: StopDeploymentCommandInput, options?: HttpHandlerOptions): Effect.Effect<StopDeploymentCommandOutput, Cause.TimeoutException | SdkError | DeploymentAlreadyCompletedError | DeploymentDoesNotExistError | DeploymentGroupDoesNotExistError | DeploymentIdRequiredError | InvalidDeploymentIdError | UnsupportedActionForDeploymentTypeError>;
    /**
     * @see {@link TagResourceCommand}
     */
    tagResource(args: TagResourceCommandInput, options?: HttpHandlerOptions): Effect.Effect<TagResourceCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ArnNotSupportedError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | InvalidArnError | InvalidTagsToAddError | ResourceArnRequiredError | TagRequiredError>;
    /**
     * @see {@link UntagResourceCommand}
     */
    untagResource(args: UntagResourceCommandInput, options?: HttpHandlerOptions): Effect.Effect<UntagResourceCommandOutput, Cause.TimeoutException | SdkError | ApplicationDoesNotExistError | ArnNotSupportedError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | InvalidArnError | InvalidTagsToAddError | ResourceArnRequiredError | TagRequiredError>;
    /**
     * @see {@link UpdateApplicationCommand}
     */
    updateApplication(args: UpdateApplicationCommandInput, options?: HttpHandlerOptions): Effect.Effect<UpdateApplicationCommandOutput, Cause.TimeoutException | SdkError | ApplicationAlreadyExistsError | ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError>;
    /**
     * @see {@link UpdateDeploymentGroupCommand}
     */
    updateDeploymentGroup(args: UpdateDeploymentGroupCommandInput, options?: HttpHandlerOptions): Effect.Effect<UpdateDeploymentGroupCommandOutput, Cause.TimeoutException | SdkError | AlarmsLimitExceededError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupAlreadyExistsError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | ECSServiceMappingLimitExceededError | InvalidAlarmConfigError | InvalidApplicationNameError | InvalidAutoRollbackConfigError | InvalidAutoScalingGroupError | InvalidBlueGreenDeploymentConfigurationError | InvalidDeploymentConfigNameError | InvalidDeploymentGroupNameError | InvalidDeploymentStyleError | InvalidEC2TagCombinationError | InvalidEC2TagError | InvalidECSServiceError | InvalidInputError | InvalidLoadBalancerInfoError | InvalidOnPremisesTagCombinationError | InvalidRoleError | InvalidTagError | InvalidTargetGroupPairError | InvalidTrafficRoutingConfigurationError | InvalidTriggerConfigError | LifecycleHookLimitExceededError | TagSetListLimitExceededError | ThrottlingError | TriggerTargetsLimitExceededError>;
}
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const makeCodeDeployService: Effect.Effect<CodeDeployService$, never, Instance.CodeDeployClientInstance>;
declare const CodeDeployService_base: import("effect/Context").TagClass<CodeDeployService, "@effect-aws/client-codedeploy/CodeDeployService", CodeDeployService$> & Effect.Tag.Proxy<CodeDeployService, CodeDeployService$> & {
    use: <X>(body: (_: CodeDeployService$) => X) => [X] extends [Effect.Effect<infer A, infer E, infer R>] ? Effect.Effect<A, E, CodeDeployService | R> : [X] extends [PromiseLike<infer A_1>] ? Effect.Effect<A_1, Cause.UnknownException, CodeDeployService> : Effect.Effect<X, never, CodeDeployService>;
};
/**
 * @since 1.0.0
 * @category models
 */
export declare class CodeDeployService extends CodeDeployService_base {
    static readonly defaultLayer: Layer.Layer<CodeDeployService, never, never>;
    static readonly layer: (config: CodeDeployService.Config) => Layer.Layer<CodeDeployService, never, never>;
    static readonly baseLayer: (evaluate: (defaultConfig: CodeDeployClientConfig) => CodeDeployClient) => Layer.Layer<CodeDeployService, never, never>;
}
/**
 * @since 1.0.0
 */
export declare namespace CodeDeployService {
    /**
     * @since 1.0.0
     */
    interface Config extends Omit<CodeDeployClientConfig, "logger"> {
        readonly logger?: ServiceLogger.ServiceLoggerConstructorProps | true;
    }
}
export {};
//# sourceMappingURL=CodeDeployService.d.ts.map