"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeDeployService = exports.makeCodeDeployService = void 0;
/**
 * @since 1.0.0
 */
const client_codedeploy_1 = require("@aws-sdk/client-codedeploy");
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Instance = __importStar(require("./CodeDeployClientInstance.js"));
const CodeDeployServiceConfig = __importStar(require("./CodeDeployServiceConfig.js"));
const Errors_js_1 = require("./Errors.js");
const commands = {
    AddTagsToOnPremisesInstancesCommand: client_codedeploy_1.AddTagsToOnPremisesInstancesCommand,
    BatchGetApplicationRevisionsCommand: client_codedeploy_1.BatchGetApplicationRevisionsCommand,
    BatchGetApplicationsCommand: client_codedeploy_1.BatchGetApplicationsCommand,
    BatchGetDeploymentGroupsCommand: client_codedeploy_1.BatchGetDeploymentGroupsCommand,
    BatchGetDeploymentInstancesCommand: client_codedeploy_1.BatchGetDeploymentInstancesCommand,
    BatchGetDeploymentTargetsCommand: client_codedeploy_1.BatchGetDeploymentTargetsCommand,
    BatchGetDeploymentsCommand: client_codedeploy_1.BatchGetDeploymentsCommand,
    BatchGetOnPremisesInstancesCommand: client_codedeploy_1.BatchGetOnPremisesInstancesCommand,
    ContinueDeploymentCommand: client_codedeploy_1.ContinueDeploymentCommand,
    CreateApplicationCommand: client_codedeploy_1.CreateApplicationCommand,
    CreateDeploymentCommand: client_codedeploy_1.CreateDeploymentCommand,
    CreateDeploymentConfigCommand: client_codedeploy_1.CreateDeploymentConfigCommand,
    CreateDeploymentGroupCommand: client_codedeploy_1.CreateDeploymentGroupCommand,
    DeleteApplicationCommand: client_codedeploy_1.DeleteApplicationCommand,
    DeleteDeploymentConfigCommand: client_codedeploy_1.DeleteDeploymentConfigCommand,
    DeleteDeploymentGroupCommand: client_codedeploy_1.DeleteDeploymentGroupCommand,
    DeleteGitHubAccountTokenCommand: client_codedeploy_1.DeleteGitHubAccountTokenCommand,
    DeleteResourcesByExternalIdCommand: client_codedeploy_1.DeleteResourcesByExternalIdCommand,
    DeregisterOnPremisesInstanceCommand: client_codedeploy_1.DeregisterOnPremisesInstanceCommand,
    GetApplicationCommand: client_codedeploy_1.GetApplicationCommand,
    GetApplicationRevisionCommand: client_codedeploy_1.GetApplicationRevisionCommand,
    GetDeploymentCommand: client_codedeploy_1.GetDeploymentCommand,
    GetDeploymentConfigCommand: client_codedeploy_1.GetDeploymentConfigCommand,
    GetDeploymentGroupCommand: client_codedeploy_1.GetDeploymentGroupCommand,
    GetDeploymentInstanceCommand: client_codedeploy_1.GetDeploymentInstanceCommand,
    GetDeploymentTargetCommand: client_codedeploy_1.GetDeploymentTargetCommand,
    GetOnPremisesInstanceCommand: client_codedeploy_1.GetOnPremisesInstanceCommand,
    ListApplicationRevisionsCommand: client_codedeploy_1.ListApplicationRevisionsCommand,
    ListApplicationsCommand: client_codedeploy_1.ListApplicationsCommand,
    ListDeploymentConfigsCommand: client_codedeploy_1.ListDeploymentConfigsCommand,
    ListDeploymentGroupsCommand: client_codedeploy_1.ListDeploymentGroupsCommand,
    ListDeploymentInstancesCommand: client_codedeploy_1.ListDeploymentInstancesCommand,
    ListDeploymentTargetsCommand: client_codedeploy_1.ListDeploymentTargetsCommand,
    ListDeploymentsCommand: client_codedeploy_1.ListDeploymentsCommand,
    ListGitHubAccountTokenNamesCommand: client_codedeploy_1.ListGitHubAccountTokenNamesCommand,
    ListOnPremisesInstancesCommand: client_codedeploy_1.ListOnPremisesInstancesCommand,
    ListTagsForResourceCommand: client_codedeploy_1.ListTagsForResourceCommand,
    PutLifecycleEventHookExecutionStatusCommand: client_codedeploy_1.PutLifecycleEventHookExecutionStatusCommand,
    RegisterApplicationRevisionCommand: client_codedeploy_1.RegisterApplicationRevisionCommand,
    RegisterOnPremisesInstanceCommand: client_codedeploy_1.RegisterOnPremisesInstanceCommand,
    RemoveTagsFromOnPremisesInstancesCommand: client_codedeploy_1.RemoveTagsFromOnPremisesInstancesCommand,
    SkipWaitTimeForInstanceTerminationCommand: client_codedeploy_1.SkipWaitTimeForInstanceTerminationCommand,
    StopDeploymentCommand: client_codedeploy_1.StopDeploymentCommand,
    TagResourceCommand: client_codedeploy_1.TagResourceCommand,
    UntagResourceCommand: client_codedeploy_1.UntagResourceCommand,
    UpdateApplicationCommand: client_codedeploy_1.UpdateApplicationCommand,
    UpdateDeploymentGroupCommand: client_codedeploy_1.UpdateDeploymentGroupCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
exports.makeCodeDeployService = effect_1.Effect.gen(function* () {
    const client = yield* Instance.CodeDeployClientInstance;
    return yield* commons_1.Service.fromClientAndCommands(client, commands, {
        errorTags: Errors_js_1.AllServiceErrors,
        resolveClientConfig: CodeDeployServiceConfig.toCodeDeployClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
class CodeDeployService extends effect_1.Effect.Tag("@effect-aws/client-codedeploy/CodeDeployService")() {
    static defaultLayer = effect_1.Layer.effect(this, exports.makeCodeDeployService).pipe(effect_1.Layer.provide(Instance.layer));
    static layer = (config) => effect_1.Layer.effect(this, exports.makeCodeDeployService).pipe(effect_1.Layer.provide(Instance.layer), effect_1.Layer.provide(CodeDeployServiceConfig.setCodeDeployServiceConfig(config)));
    static baseLayer = (evaluate) => effect_1.Layer.effect(this, exports.makeCodeDeployService).pipe(effect_1.Layer.provide(effect_1.Layer.effect(Instance.CodeDeployClientInstance, effect_1.Effect.map(CodeDeployServiceConfig.toCodeDeployClientConfig, evaluate))));
}
exports.CodeDeployService = CodeDeployService;
//# sourceMappingURL=CodeDeployService.js.map